package com.labs;


import java.io.InputStream;
import java.util.Random;
import java.util.Stack;


import android.app.Activity;

import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.PointF;
import android.graphics.Rect;
import android.graphics.RectF;
import android.graphics.drawable.AnimationDrawable;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.SubMenu;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.SurfaceHolder.Callback;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
/**
 * 
 * @author aandrese
 * @version 4.4
 * @category Nuts About Pong
 */
@SuppressWarnings("unused")
public class GameplayMale extends Activity implements Callback
{
	
	private static final String TAG = "myTAG";
	
	


	///////////////////////////////////////values
	public long deviceDT;		//difference in current system time of connected devices
	public Boolean ismyserve;	//determines if it is the user's serve
	public int my_score = 0;	//represents user's score
	public int his_score = 0;	//represents opponent's score
	public int win_score = 10;	//points needed to win
	private float AI_response;	//used for difficulty level

	private static final boolean D = false;//set true to enable debugging aid

	//options menu values
	private static final int EASY = 1;
	private static final int MEDIUM = 2;
	private static final int HARD = 3;
	private static final int EXPERT = 4;
	private static final int SOUND = 5;

	///////////////////////////////////////drawing stuff
	public SurfaceView myview;
	public SurfaceHolder myholder;
	public PointF gridcenter;
	public Paint textpaint;	
	public Paint ballpaint;
	public Paint paddlepaint;	
	public Paint Squirrelpaint; //TODO:

	
	public int xmin, xmax, ymin, ymax; //TODO:
	
	
	private float hratio;
	private float wratio;   
	/////////////////////
	public AnimationDrawable particles;
	public ImageView imageAnim;
	public static boolean didCollide=false;
	public boolean isLocked=false;
	public int counter=0;
	Matrix matrix = new Matrix();
	public static char collidedAt;
	public static float xcol;
	public static float ycol;	
	public Bitmap bitmapTable, bitmapAcorn, bitmapFemale, bitmapMale;
	public InputStream isTable,isAcorn,isFemale,isMale;
	Stack<InputStream> isParticle = new Stack<InputStream>();
	Stack<Bitmap> bitmapParticle = new Stack<Bitmap>();	


	///////////////////////////////////////game objects
	private GameplayMale self;	
	
	public int maxacorns = 10; //TODO:
	public ball[] myAcorns;	//TODO:
	public int Acornsinplay;//TODO:represents number of acorns in play
	public int serveque; 	//TODO:represents number of acorns in current serve queue
	
	
	
	public Squirrel mySquirrel; //TODO:
	public Squirrel hisSquirrel;//TODO:
	public Boolean ismale;//TODO:
	public Random myrand;//TODO:
	
	
	
	protected volatile physics p;


	///////////////////////////////////////sound FX
	private int SFX = 1;

	///////////////////////////////////////
	
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) 
	{
	  boolean result = super.onCreateOptionsMenu(menu);

	  SubMenu AI_Menu = menu.addSubMenu("Difficulty Level");
	  AI_Menu.add(0, EASY, 0, "Easy");
	  AI_Menu.add(0, MEDIUM, 0, "Medium");
	  AI_Menu.add(0, HARD, 0, "Hard");
	  AI_Menu.add(0, EXPERT, 0, "Expert");
	  
	  menu.add(0, SOUND, 0, "Sound On/Off");
	  
	  return result;
	}

	/* Handles menu item selections */
	public boolean onOptionsItemSelected(MenuItem item) 
	{

	    switch (item.getItemId())
	    {
	    case EASY:	
	    	AI_response = (float) .25;

	    	return true;

	    case MEDIUM:
	    	AI_response = (float) .45;

	    	return true;

	    case HARD:
	    	AI_response = (float) .75;

	    	return true;

	    case EXPERT:
	    	AI_response = (float) .85;

	    	return true;
	    	
	    case SOUND:

	    	SFX *=-1;
	    	return true;
	    }
	    p.resume();
	    return false;
	}


	

    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        self = this;
        setContentView(R.layout.main);
        myview = (SurfaceView) findViewById(R.id.surface);
        myholder = myview.getHolder();
        myholder.addCallback(self);
        gridcenter = new PointF(50, 75);
        textpaint = new Paint();
        ballpaint = new Paint();
        paddlepaint = new Paint();
        
        isTable=this.getResources().openRawResource(R.drawable.officialgameplayscreencopy);
        bitmapTable = BitmapFactory.decodeStream(isTable);
        isAcorn=this.getResources().openRawResource(R.drawable.acorn);
        bitmapAcorn = BitmapFactory.decodeStream(isAcorn);
        isMale=this.getResources().openRawResource(R.drawable.malesquirrelbackcopy);
        bitmapMale = BitmapFactory.decodeStream(isMale);
        isFemale=this.getResources().openRawResource(R.drawable.throwingsquirrelchickcopy);
        bitmapFemale = BitmapFactory.decodeStream(isFemale); 

        
        myAcorns = new ball[10];	//TODO:
        Acornsinplay = 0;			//TODO:
    	serveque = 0; 				//TODO:

    	xmax = (int) ball.xmax;			//TODO:
    	ymax = (int) ball.ymax;			//TODO:
    	xmin = (int) ball.xmin;			//TODO:
    	ymin = (int) ball.ymin;			//TODO:
    	
    	myrand = new Random(System.currentTimeMillis());//TODO:
    	ismale = true;//TODO:
    	    
        
        mySquirrel = new Squirrel();	//TODO:
        hisSquirrel = new Squirrel(10);	//TODO:
        textpaint.setColor(Color.WHITE);
        ballpaint.setColor(Color.GREEN);
        paddlepaint.setColor(Color.RED);
        
        AI_response = (float) .45;
        
     

    }
    
    @Override										//TODO: changed to mySquirrel
    public boolean onTouchEvent(MotionEvent event) 
    {
        if (event.getAction() == MotionEvent.ACTION_DOWN) 
        {
            float xpos = event.getX();
            mySquirrel.xpos = xpos / wratio;
            
            
            mySquirrel.padpos.add(mySquirrel.xpos);
            mySquirrel.xvel = 0;
        } 
        else if (event.getAction() == MotionEvent.ACTION_MOVE)
        {
            float xpos = event.getX();
            mySquirrel.xpos = xpos / wratio;
            


            long current_time = System.currentTimeMillis();
            long dt = current_time - mySquirrel.last_update;
            mySquirrel.last_update = current_time;
            mySquirrel.xvel = (mySquirrel.xpos - mySquirrel.padpos.get(1)) *dt;
            mySquirrel.padpos.add(mySquirrel.xpos);
            
        }
        else if (event.getAction() == MotionEvent.ACTION_UP)
        {
        	float xpos = event.getX();
            mySquirrel.xpos = xpos / wratio;
            
           
            
            
            mySquirrel.padpos.add(mySquirrel.xpos);
            mySquirrel.xvel = 0;        	
        }	
        try
        {
        	if (!p.playing)
        	{
        		handle_win();
        	}
        	
        }
        catch(NullPointerException exception)
        {
        	
        }
        
        
        return false;
    }

    
    
    
    public class physics extends Thread
    {
    	protected long lastAcorn;
    	// = System.currentTimeMillis();	
    	//TODO:represents last time an acorn was added to serveque
    	
    	protected long serve_que_interval = 2000
    	/*3 seconds*/;	
    	//TODO:represents time interval in between serveque++ (5 seconds)
    	
    	//TODO:
    	//TODO:
    	//TODO:


    	private volatile boolean running = true;
    	private volatile boolean playing = false;
    	
    
    	public void run()
    	{
            while (running) 
            {
            	drawit();
            	
            	if ((myAcorns != null)&& playing)	//TODO:
            	{
            		
            		
            		
            		if (((Acornsinplay + serveque) < maxacorns)	//TODO:each given time interval, add acorn to serveque
            				&&((System.currentTimeMillis() - serve_que_interval) > lastAcorn))//TODO:
            		{
            			serveque++;								//TODO:
            			lastAcorn = System.currentTimeMillis();	//TODO:
            		}
            		
            		
            		
            			
            			
            		int x = collision();				//TODO:
            		update_hisPad();
            		
            		int pointwin = 0;	//TODO:
            		for (int i=0; (i< Acornsinplay && pointwin==0); i++)//TODO:
            		{
            			myAcorns[i].update();	//TODO:
            		}
            		drawit();
            			
            		if (x == 1)
            		{
            			my_score++;
            			playing = false;
            			Acornsinplay = 0;//TODO
            			serveque = 0;//TODO
            			
            		
            	Intent ouchintentfemale= new Intent(self, OuchFemale.class);
            				self.startActivity(ouchintentfemale);	
            			
            			
            			//}		
            		}
            		
            		if (x==-1)
            		{
            			his_score++;
            			playing = false;
            			Acornsinplay = 0;//TODO
            			serveque = 0;//TODO
            			
            	Intent ouchintentmale= new Intent(self, OuchMale.class);
        				self.startActivity(ouchintentmale);			

            			
            			
            			
            			
            			
            		}
            	}
            }
    	}
        
    	
		
    	
    	
    	public void safeStop() 
        {
        	playing = false;
            running = false;
            interrupt();
        }
    }
    
    
    private void handle_win()
    {

    	if (my_score >= win_score)
    	{
    		Intent winintentmale= new Intent(self, WinMale.class);
			self.startActivityForResult(winintentmale,0);	
    	}
    	
    	if (his_score>=win_score)
    	{
    		
    		Intent loseintentmale= new Intent(self, LoseMale.class);
			self.startActivityForResult(loseintentmale,0);	
    		
    	}
    	else
    	{
        	serveque = 0;		//TODO:out ball on serveque
        	p.lastAcorn = System.currentTimeMillis();
    		p.playing = true;
    	}
    }
    
    @SuppressWarnings("static-access")
	public int collision()
    {
    	int ret_val=2;//TODO:
    	//p.suspend();
    	try {
			p.sleep(1);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	for (int i=0; (i < Acornsinplay)&&(ret_val ==2); i++)//TODO:
    	{
    		float xdiff = mySquirrel.xpos - myAcorns[i].xpos;//TODO:
    		float ydiff = mySquirrel.ypos - myAcorns[i].ypos;    	//TODO:	
    		float distance = (float) Math.sqrt((xdiff*xdiff)+(ydiff*ydiff));//TODO:
    		if (distance < (mySquirrel.rad + myAcorns[i].rad))//TODO:
    			ret_val = -1;//TODO:
    		
    		xdiff = hisSquirrel.xpos - myAcorns[i].xpos;//TODO:
    		ydiff = hisSquirrel.ypos - myAcorns[i].ypos;//TODO:    		
    		distance = (float) Math.sqrt((xdiff*xdiff)+(ydiff*ydiff));//TODO:
    		if (distance < (mySquirrel.rad + myAcorns[i].rad))//TODO:
    			ret_val = 1;//TODO:
    		
    	}
    	return ret_val;//TODO:
    	
    	
    	
    
    	
    }

    public void update_hisPad()
    {
    	if (D) Log.d(TAG, "update his pad"); //TODO:
    	long current_time = System.currentTimeMillis();
    	long time_diff = current_time - hisSquirrel.last_update;   
    	float newxpos = hisSquirrel.xpos;
    	float newxvel = hisSquirrel.xvel;
    	    	
    	for (int i=0; (i < Acornsinplay); i++)//TODO://CPU player "should" avoid acorns
    	{
    		float xdiff = (hisSquirrel.xpos - myAcorns[i].xpos);//TODO:
    		float ydiff = (hisSquirrel.ypos - myAcorns[i].ypos);    	//TODO:	
    		float distance = (float) Math.sqrt((xdiff*xdiff)+(ydiff*ydiff));//TODO:
    		
    		if (distance < (hisSquirrel.rad + myAcorns[i].rad)+3)
    			newxpos += (myAcorns[i].xpos-(newxpos-hisSquirrel.rad+1));	//TODO:
			newxvel *= 1;							//TODO:
    		
    		xdiff = hisSquirrel.xpos - myAcorns[i].xpos;//TODO:
    		ydiff = hisSquirrel.ypos - myAcorns[i].ypos;//TODO:    		
    		distance = (float) Math.sqrt((xdiff*xdiff)+(ydiff*ydiff));//TODO:
    		
    		if (distance < (mySquirrel.rad + myAcorns[i].rad)+3)//TODO:
    			newxpos -= ((newxpos+hisSquirrel.rad+1) -myAcorns[i].xpos);	//TODO:
			newxvel *= -1;							//TODO:
    		
    	}
    	
    	if (hisSquirrel.xpos-hisSquirrel.rad< xmin)			//TODO: makes opponent go back and forth
		{
			newxpos += (xmin-(newxpos-hisSquirrel.rad));	//TODO:
			newxvel *= -1;							//TODO:
		}
    	
    	
		if (hisSquirrel.xpos+hisSquirrel.rad> xmax)			//TODO:
		{
			newxpos -= ((newxpos+hisSquirrel.rad) -xmax);	//TODO:
			newxvel *= -1;							//TODO:
		}
		newxpos += (newxvel * time_diff)/100;
		
		
		
		//TODO: launch ball if available
		if (ismale && (serveque>0) && (Acornsinplay < maxacorns))
		{
			myAcorns[Acornsinplay] = new ball(hisSquirrel.xpos, hisSquirrel.ypos+10, (float) (myrand.nextFloat()*2.512 + .314));
			Acornsinplay++;
			serveque--;
		}
	



				
		hisSquirrel.xpos = newxpos;
		hisSquirrel.xvel = newxvel;
		hisSquirrel.last_update = current_time;
    }

    
    
    
    
    
    
    
    
    
    
    
    public void drawit()
    {  	
    	Canvas c = null;
    	try {
    		c = myholder.lockCanvas();
    		if (c != null) 
    		{
    			hratio = c.getHeight()/ball.ymax;//TODO:
    			wratio = c.getWidth()/ball.xmax;   //TODO: 			
    			
    			//draw background
    			c.drawBitmap(bitmapTable, null,new Rect(0,0,c.getWidth(),c.getHeight()),null);
    			                                //draw ball c.drawBitmap(bitmapBall, myBall.xpos*wratio-myBall.rad*wratio, myBall.ypos*hratio-myBall.rad*wratio, null); //draw my paddle c.drawBitmap(bitmapBlue,null,new RectF((myPaddle.xpos-(myPaddle.width/2))*wratio, (myPaddle.ypos-(myPaddle.height/2))*hratio, (myPaddle.xpos+(myPaddle.width/2))*wratio, (myPaddle.ypos+(myPaddle.height/2))*hratio), null); //draw opponent paddle c.drawBitmap(bitmapRed,null,new RectF((hisPaddle.xpos-(hisPaddle.width/2))*wratio, (hisPaddle.ypos-(hisPaddle.height/2))*hratio, (hisPaddle.xpos+(hisPaddle.width/2))*wratio, (hisPaddle.ypos+(hisPaddle.height/2))*hratio), null);
    			
    			
    			//c.drawRect(0, 0, c.getWidth(), c.getHeight(), backgroundpaint);//TODO:make compatable with 1.6
    			//draw score
    			textpaint.setTextSize(10*wratio);
    			c.drawText(my_score + " - " + his_score, (gridcenter.x-10)*wratio,
    					gridcenter.y*hratio, textpaint);
    			
    			
    			
    			//TODO: draw acorns
    			for (int i=0; (i< Acornsinplay); i++)//TODO:
    			{
    			c.drawBitmap(bitmapAcorn, null, new RectF(
    					wratio*(myAcorns[i].xpos-myAcorns[i].rad),//left border
    					hratio*(myAcorns[i].ypos-myAcorns[i].rad),//top border
    					wratio*(myAcorns[i].xpos+myAcorns[i].rad),//right border
    					hratio*(myAcorns[i].ypos+myAcorns[i].rad)),//bottom border
    					null);
    			}
    			//TODO: draw my squirrel
    			c.drawBitmap(bitmapMale, null, new RectF(
    					wratio*(mySquirrel.xpos-mySquirrel.rad-4),//left border
    					hratio*(mySquirrel.ypos-mySquirrel.rad-4),//top border
    					wratio*(mySquirrel.xpos+mySquirrel.rad+4),//right border
    					hratio*(mySquirrel.ypos+mySquirrel.rad+4)),//bottom border
    					null);
    			
    			//TODO: draw his squirrel
    			c.drawBitmap(bitmapFemale, null, new RectF(
    					wratio*(hisSquirrel.xpos-hisSquirrel.rad),//left border
    					hratio*(hisSquirrel.ypos-hisSquirrel.rad),//top border
    					wratio*(hisSquirrel.xpos+hisSquirrel.rad),//right border
    					hratio*(hisSquirrel.ypos+hisSquirrel.rad)),//bottom border
    					null);
    			//c.drawCircle(mySquirrel.xpos*wratio,  mySquirrel.ypos*hratio, //TODO:
    			//		mySquirrel.rad*wratio, paddlepaint);//TODO:
    			
    			
    			
    			
    			
    			/*
    			
    			
    			//draw ball 
    			c.drawCircle(myBall.xpos*wratio, myBall.ypos*hratio,
    					myBall.rad*wratio, ballpaint);
    			//draw my paddle
    			c.drawRect((mySquirrel.xpos-(mySquirrel.width/2))*wratio,
    					(mySquirrel.ypos+(mySquirrel.height/2))*hratio,
    					(mySquirrel.xpos+(mySquirrel.width/2))*wratio,
    					(mySquirrel.ypos-(mySquirrel.height/2))*hratio, paddlepaint);
    			//draw opponent paddle
    			c.drawRect((hisSquirrel.xpos-(hisSquirrel.width/2))*wratio,
    					(hisSquirrel.ypos+(hisSquirrel.height/2))*hratio,
    					(hisSquirrel.xpos+(mySquirrel.width/2))*wratio,
    					(hisSquirrel.ypos-(hisSquirrel.height/2))*hratio, paddlepaint);
    					
    					*/

    		}
    	} finally {
    		if (c != null) 
    		{
    			myholder.unlockCanvasAndPost(c);
    		}
    	}
    }

    public void surfaceCreated(SurfaceHolder holder)
	{
		p = new physics();
		//mp = MediaPlayer.create(this, R.raw.benny);
        //mp.setLooping(true);
        //mp.start();
		p.start();
	}
	//@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width, int height){
	}
	//@Override
	public void surfaceDestroyed(SurfaceHolder holder)
	{
		try {
			p.safeStop();
		} finally {
			p = null;
		}		
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data);
		if ((resultCode == Activity.RESULT_OK) && (data.getBooleanExtra("main", false)==true))
		{
			setResult(Activity.RESULT_OK);
//			Intent main = new Intent();
//			main.putExtra("main", main);
			finish();
		}else {
			setResult(Activity.RESULT_CANCELED);
			finish();
		}
	}
}